﻿class TrackSegment extends MovieClip
{
	var mStart:Vect;
	var mEnd:Vect;
	var mDir:Vect;
	
	public function Set(aStart:Vect, anEnd:Vect)
	{
		mStart = aStart;
		mEnd = anEnd;
		mDir = new Vect(anEnd.x - aStart.x, anEnd.y - aStart.y);
		mDir.normalize();
		lineStyle (3, 0xFF0000, 100);
		moveTo(mStart.x, mStart.y-1);
		lineTo(mEnd.x, mEnd.y-1.5);
		lineStyle (3, 0x0000FF, 100);
		moveTo(mStart.x, mStart.y+1);
		lineTo(mEnd.x, mEnd.y+1.5);
	}
	
	public function getDistance(xpos:Number, ypos:Number)
	{
		var myPoint:Object = {x:xpos, y:ypos}
		
		globalToLocal(myPoint);
		xpos = myPoint.x;
		ypos = myPoint.y;
		
		var s2p:Vect = new Vect(xpos,ypos);
		s2p.subtract(mStart);
		
		var s2eDir:Vect = new Vect(mEnd.x, mEnd.y);
		s2eDir.subtract(mStart);
		var lineLength = s2eDir.GetLength();
		s2eDir.normalize();
		
		var normal:Vect = s2eDir.CreateLeftRotated();

		var alongLine = s2eDir.dot(s2p);
		var alongNormal = normal.dot(s2p);
		return alongNormal;
	}
	
	public function intersect(xpos:Number, ypos:Number, radius:Number)
	{	
		var myPoint:Object = {x:xpos, y:ypos}
		
		globalToLocal(myPoint);
		xpos = myPoint.x;
		ypos = myPoint.y;
		
		var s2p:Vect = new Vect(xpos,ypos);
		s2p.subtract(mStart);
		
		var s2eDir:Vect = new Vect(mEnd.x, mEnd.y);
		s2eDir.subtract(mStart);
		var lineLength = s2eDir.GetLength();
		s2eDir.normalize();
		
		var normal:Vect = s2eDir.CreateLeftRotated();

		var alongLine = s2eDir.dot(s2p);
		var alongNormal = normal.dot(s2p);
		
		if ( Math.abs(alongNormal) < radius )
		{
			if ( alongLine > -radius && alongLine < lineLength + radius )
			{
				return this;
			}
		}
		
		return undefined;
	}
	
	function GetLeftNormal():Vect
	{
		return mDir.CreateLeftRotated();
	}
	
	function GetRightNormal():Vect
	{
		return mDir.CreateRightRotated();
	}
	
	function GetDir():Vect
	{
		return mDir;
	}
	
	
}